Django_Tutorial_1/Tut_app/Tut_app/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
from django.contrib.auth import views as auth_views




urlpatterns = [
    path('main/', include('main.urls')),
    path('admin/', admin.site.urls),
    path('login/', auth_views.LoginView.as_view(), name='login'),
    path('logout/', auth_views.LogoutView.as_view(), name='logout'),
]  + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

Django_Tutorial_1/Tut_app/main/urls.py
from django.urls import path
from .views import *


from django.urls import include, path
from rest_framework import routers
from .views import UserViewSet,GameViewSet

router = routers.DefaultRouter()
router.register(r'users', UserViewSet)
router.register(r'games', GameViewSet)


urlpatterns = [
    path('gry/', lista_gier, name='lista_gier'),
    path('gry/nowa', nowa_gra, name='nowa_gra'),
    path('gry/edytuj/<int:id>/', edytuj_gre, name='edytuj_gre'),
    path('gry/usun/<int:id>/', usun_gre, name='usun_gre'),
    path('gry/opinie/<int:id>/', opinie, name='opinie'),
    path('', include(router.urls)),

]

Django_Tutorial_1/Tut_app/main/models.py
from django.db import models

# Create your models here.

class ExtraInfo(models.Model):

    MULTI = {
        (0, 'Tak'),
        (1, 'Nie'),
        (2, 'Nie wiadomo'),
        (3, 'Tylko LAN')
    }
    MULTI2 = {
        (0, 'Tak'),
        (1, 'Nie'),
        (2, 'Nie wiadomo')
    }

    Multiplayer = models.IntegerField(default=0, choices=MULTI)
    Kampania = models.IntegerField(default=0, choices=MULTI2)

class Game(models.Model):

    name = models.CharField(max_length=128)
    description = models.TextField(max_length=256, default='')
    type = models.CharField(max_length=60, default='')
    released = models.DateField(blank=True, null = True)
    ign_rating = models.DecimalField(decimal_places=2,max_digits=4,blank=True, null = True)
    photo = models.ImageField(blank=True, null = True, upload_to='obrazy')

    info = models.OneToOneField(
        ExtraInfo,
        on_delete=models.CASCADE,
        primary_key=False,
    )



    def __str__(self):
        return self.name_with_year()

    def name_with_year(self):
        return str(self.name) +' ('  + str(self.released) + ')'



class Review(models.Model):
    text = models.CharField(default='',blank=True, null=True, max_length=512)
    stars = models.IntegerField(default=5)
    game = models.ForeignKey(Game, related_name='reviews', on_delete=models.CASCADE)



    def __str__(self):
        return self.name()

    def name(self):
        return str(self.text[:50])


class Bohater(models.Model):
    imie = models.CharField(max_length=128)
    nacja = models.CharField(max_length=128)
    gry = models.ManyToManyField(Game)

    def __str__(self):
        return self.imie

Django_Tutorial_1/Tut_app/main/forms.py
from django.forms import ModelForm
from .models import Game


class GameForm(ModelForm):
    class Meta:
        model = Game
        fields = ['name', 'type', 'description', 'released','ign_rating', 'photo']

Django_Tutorial_1/Tut_app/main/views.py
from django.shortcuts import render
from django.http import HttpResponse
from django.contrib.auth.decorators import login_required
from django.shortcuts import render, redirect, get_object_or_404
from .models import Game, Review
from .forms import GameForm


from django.contrib.auth.models import User, Group
from rest_framework import viewsets
from .serializers import UserSerializer, GameSerializer
# Create your views here.


def lista_gier(request):
    gry = Game.objects.filter(id__lt=250)
    return render(request, 'lista_gier.html', {'gry': gry})


@login_required
def nowa_gra(request):
    form = GameForm(request.POST or None, request.FILES or None)
    if form.is_valid():
        form.save()
        return redirect(lista_gier)

    return render(request, 'gra_forma.html', {'form': form})


@login_required
def edytuj_gre(request, id):
    gra = get_object_or_404(Game, pk=id)

    form = GameForm(request.POST or None, request.FILES or None, instance=gra)
    if form.is_valid():
        form.save()
        return redirect(lista_gier)

    return render(request, 'gra_forma.html', {'form': form})


def usun_gre(request, id):
    gra = get_object_or_404(Game, pk=id)

    if request.method == 'POST':
        gra.delete()
        return redirect(lista_gier)
    return render(request, 'potwierdz.html', {'gra': gra})


def opinie(request, id):

    gra = get_object_or_404(Game, pk=id)
    gry = Review.objects.filter(game=gra)



    return render(request, 'opinie.html', {'gra': gra, 'gry':gry, 'empty_stars':0})




class UserViewSet(viewsets.ModelViewSet):
    """
    API endpoint that allows users to be viewed or edited.
    """
    queryset = User.objects.all().order_by('-date_joined')
    serializer_class = UserSerializer


class GameViewSet(viewsets.ModelViewSet):
    """
    API endpoint that allows users to be viewed or edited.
    """
    queryset = Game.objects.all()
    serializer_class = GameSerializer

Django_Tutorial_1/Tut_app/templates/gra_forma.html
{% extends 'main.html' %}
{% load static %}

{% block title %} Dodaj Grę {% endblock %}


{% block body %}
<form method="POST" enctype="multipart/form-data">
    {% csrf_token %}
    {{ form }}
    <button type="submit">Dodaj Gre</button>
    <a href="lista_gier.html">
        <button> Powrót </button>
    </a>
</form>

{% endblock %}

Django_Tutorial_1/Tut_app/templates/lista_gier.html
{% extends 'main.html' %}
{% load static %}


{% block title %} Lista Gier {% endblock %}


{% block body %}

<div class="jumbotron">
    <h1 class="display-4">Witaj {{ user.username }}</h1>

    <hr class="my-4">
    <p>{% if user.is_authenticated %}
        <a href="/logout/">
            <button>Log Out!</button>
        </a>
        {% else %}
        <a href="/login/">
            <button>Log In!</button>
        </a>
        {% endif %}
    </p>
    <p class="lead">
        <button>
            <a href="{% url 'nowa_gra' %}">Dodaj Grę <i class="fas fa-plus-square"></i></a>
        </button>

    </p>
</div>

<div>
    <h1>

    </h1>

    <br>
    <br>
</div>
<div class="row" style="padding:10% width:400px">
    {% for gra in gry %}
    <div class="col-lg-4">

        <div class="card">

            <div class="card-body ">
                <div>
                    <img src="/media/{{gra.photo}}" alt="...">
                </div>
                <div class="row">
                    <div class="col-sm-8">
                        <h4>{{ gra.name }} - {{gra.type}} </h4>
                    </div>
                    <div class="col-sm-4">
                        <a href="{% url 'edytuj_gre' gra.id %}"><i class="fas fa-2x fa-edit"></i></a>

                        <a href="{% url 'usun_gre' gra.id%}"> <i class="fas fa-2x fa-trash-alt"></i></a>

                    </div>
                    <p class="desc">{{ gra.description }}</p>



                </div>
                <h5> MultiPlayer: {{ gra.info.get_Multiplayer_display}}  </h5>
                <h5> Kampania: {{ gra.info.get_Kampania_display}}</h5>

            </div>
        </div>
    </div>


    {% endfor %}
</div>

<br>
<br>


{% endblock %}

Django_Tutorial_1/Tut_app/templates/main.html
{% load static %}
{% load bootstrap %}

<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">

    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.10.1/css/all.css"
          integrity="sha384-wxqG4glGB3nlqX0bi23nmgwCSjWIW13BdLUEYC4VIMehfbcro/ATkyDsF/AbIOVe" crossorigin="anonymous">
    <link rel="stylesheet" href="{%static 'moj.css'%}">
    <title> {% block title %} {% endblock %}</title>
</head>
<body>

    {% block body %} {% endblock %}

</body>
</html>

Django_Tutorial_1/Tut_app/templates/opinie.html
{% extends 'main.html' %}
{% load static %}

{% block title %} Opinie {% endblock %}


{% block body %}
<div class="col-lg-8">
    <div class="review">
        <div class="card">

            <div class="card-body">
                <div>
                    <img src="/media/{{gra.photo}}" alt="...">
                </div>
                <div class="row">
                    <div class="col-sm-8">
                        <h4>{{ gra.name }} - {{gra.type}} </h4>
                    </div>
                    <div class="col-sm-4">
                        <a href="{% url 'edytuj_gre' gra.id %}"><i class="fas fa-2x fa-edit"></i></a>

                        <a href="{% url 'usun_gre' gra.id%}"> <i class="fas fa-2x fa-trash-alt"></i></a>

                    </div>
                    <p class="desc">{{ gra.description }}</p>


                </div>
                <h5> MultiPlayer: {{ gra.info.get_Multiplayer_display}} </h5>
                <h5> Kampania: {{ gra.info.get_Kampania_display}}</h5>

            </div>
        </div>
    </div>
</div>

{% for gra in gry %}
<div class="col-sm-8">
    <div class="card">
        <div class="col-sm-3">
            {% with ''|center:gra.stars as range %}
            {% for _ in range %}
            <i class="fas fa-star"></i>
            {% endfor %}
            {% endwith %}

        </div>


        <div class="card-body">
            {{gra.text}}
        </div>
    </div>
</div>
{% endfor %}

{% endblock %}

Django_Tutorial_1/Tut_app/templates/potwierdz.html
{% extends 'main.html' %}
{% load static %}

{% block title %} Potwierdź {% endblock %}


{% block body %}
<h1>Czy chcesz usunąć {{gra.name}} ??</h1>

 <form method="post">
     {% csrf_token %}
     <button type="submit"> Tak, chcę</button>
 </form>


{% endblock %}